#include <boarddefs.h>
#include <IRremoteInt.h>
#include <ir_Lego_PF_BitStreamEncoder.h>
#include <IRremote.h>

#define motorPin1a 28 // Marche avant du premier moteur
#define motorPin1b 26 // Marche arrière du premier moteur
#define speedPin1 6 
#define motorPin2a 32 // Marche avant du deuxième moteur
#define motorPin2b 34 // Marche arrière du deuxième moteur
#define speedPin2 5
#define standby 30
#define RECV_PIN1 47
#define RECV_PIN2 31
//#define sendPin 3
#define trigPin 22
#define echoPin 24

//IRsend irsend; //PIN 3!!!
IRrecv irrecv1(RECV_PIN1);
IRrecv irrecv2(RECV_PIN2);
decode_results results;

const byte COLOR_BLACK = 0b000;
const byte COLOR_RED = 0b100;
const byte COLOR_GREEN = 0b010;
const byte COLOR_BLUE = 0b001;
const byte COLOR_MAGENTA = 0b101;
const byte COLOR_CYAN = 0b011;
const byte COLOR_YELLOW = 0b110;
const byte COLOR_WHITE = 0b111;

const byte ledR = 10;
const byte ledV = 11;
const byte ledB = 12;

int Mspeed = 0; 
int seuil = 10;

long distance;
boolean sensRotation;

void look (void){ 

  long temps;

  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  pinMode(echoPin, INPUT);
  temps = pulseIn(echoPin, HIGH);

  distance = temps * 340/(2*10000); 
  
}

void displayColor(byte color) 
{

  digitalWrite(ledR, bitRead(color, 2));
  digitalWrite(ledV, bitRead(color, 1));
  digitalWrite(ledB, bitRead(color, 0));

  // Version anode commune
  //digitalWrite(PIN_LED_R, !bitRead(color, 2));
  //digitalWrite(PIN_LED_G, !bitRead(color, 1));
  //digitalWrite(PIN_LED_B, !bitRead(color, 0));
}


void setup() {

  Serial.begin(9600);
  pinMode(standby, OUTPUT);
  pinMode(motorPin1a, OUTPUT);
  pinMode(motorPin1b, OUTPUT);
  pinMode(speedPin1, OUTPUT);
  pinMode(motorPin2a, OUTPUT);
  pinMode(motorPin2b, OUTPUT);
  pinMode(speedPin2, OUTPUT);
  
  pinMode(ledR, OUTPUT);
  pinMode(ledV, OUTPUT);
  pinMode(ledB, OUTPUT);
  displayColor(COLOR_BLACK);
  
  pinMode(echoPin, INPUT);
  pinMode(trigPin, OUTPUT);
  digitalWrite(trigPin, LOW);
  
  Serial.println("Enable IRin");
  irrecv1.enableIRIn();
  irrecv2.enableIRIn();
  Serial.println("Enable IRin");
  
  look();
  randomSeed(distance);
  sensRotation = random(2);
}

/*void emetteur()
{
  for(int i=0;i<3;i++)
  {
    irsend.sendSony(0xa90,12);
    delay(40);
  }
  delay(500);
}
*/
void loop() {

  //emetteur();
  Mspeed=255;
  look();
  if(distance>seuil)
  {
    displayColor(COLOR_GREEN);
    delay(1000);
    digitalWrite(standby,HIGH);
    digitalWrite(motorPin1a,HIGH);
    digitalWrite(motorPin1b,LOW);
    analogWrite(speedPin1,Mspeed);
    
    digitalWrite(motorPin2a,HIGH);
    digitalWrite(motorPin2b,LOW);
    analogWrite(speedPin2,Mspeed);
    
    Serial.println(distance);
    delay(100);
  }

  else
 {
   look();
   if((distance <= seuil) && distance!=0)
   {
    analogWrite(speedPin1,Mspeed); 
    digitalWrite(motorPin1a,sensRotation); 
    digitalWrite(motorPin1b,!(sensRotation)); 

    analogWrite(speedPin2,Mspeed); 
    digitalWrite(motorPin2a,!(sensRotation));
    digitalWrite(motorPin2b,sensRotation); 
      
    displayColor(COLOR_RED);
    delay(1000);
    Serial.println(distance);

    delay(100);
   }
  }
  while(irrecv1.decode(&results))//tourne vers capteur1 droite
  {
    displayColor(COLOR_BLUE);
    delay(1000);
    digitalWrite(standby,HIGH);
    digitalWrite(motorPin1a,HIGH);
    digitalWrite(motorPin1b,LOW);
    analogWrite(speedPin1,Mspeed+40);
    
    digitalWrite(motorPin2a,HIGH);
    digitalWrite(motorPin2b,LOW);
    analogWrite(speedPin2,Mspeed+20);
    
    Serial.println(results.value, HEX);
    irrecv1.resume();
  }
  
  while(irrecv2.decode(&results))//tourne vers capteur2 gauche
  {
    displayColor(COLOR_BLUE);
    delay(1000);
    digitalWrite(standby,HIGH);
    digitalWrite(motorPin1a,HIGH);
    digitalWrite(motorPin1b,LOW);
    analogWrite(speedPin1,Mspeed+40);
    
    digitalWrite(motorPin2a,HIGH);
    digitalWrite(motorPin2b,LOW);
    analogWrite(speedPin2,Mspeed+20);
    Serial.println(results.value, HEX);
    irrecv2.resume();
  }
    
}
